;
;
;	File: timer.ASM
;

	list	p=16f628A
	#include p16f628A.inc
	#include globals.inc

	extern counter
	;extern counter1
	;extern sectimer
	
	

;------------------------------------------------------------------------------
BANK0	UDATA
;------------------------------------------------------------------------------
COUNT		RES	1	;COUNT OF INTERRUPTS
COUNT1		RES	1	;COUNT FOR  1 SECOND TIMER
COUNT2      RES 1
COUNT3		RES 1
;------------------------------------------------------------------------------
PROG0		CODE			; program code section
;------------------------------------------------------------------------------
TimerInt 	; Interrupt routine

		global TimerInt		; Define as global 

intsOff		bcf INTCON, T0IE	;Disable timer interrupts
			bcf INTCON, T0IF    ;clear interrupt flag
            bsf INTCON, GIE     ;Enable global interrupt
	
;-------------- Insert no new code above here ---------------------------------
	 
        	
		;*********************************************************************
		; 1 ms timer function calls
		;*********************************************************************
		bcf  STATUS, RP0		;Select Bank 0
		bcf  STATUS, RP1	

		;....... 1ms  timer counter here.....	
		;call sectimer		
		;call counter
           
	    ;test toggle LED here...
        ;bcf  	PORTB, POWERLED 		;Turn off LED 
        
         
		;....................................
	
		incf  COUNT, f
		movlw  .10		;Compare count to 10 decimal
		subwf COUNT, W		;Store the result back in 
		btfss STATUS, C		;Is the result 0, skip if no
    	goto  exittimer
		clrf  COUNT		;Clear count register
       
		;**********************************************************************
		; 10ms timer function calls
		;**********************************************************************
		;....... 10ms  timer counter here.....	
		call counter
		;
        ;test toggle LED off here...
		;bcf  	PORTB, POWERLED 		;Turn off LED 
		
		;....................................

    	incf    COUNT1, f
		movlw   .10			    ;Compare count to 100 decimal
		subwf   COUNT1, W		;Store the result back in 
		btfss   STATUS, C		;Is the result 0, skip if no
		goto    exittimer
		clrf 	COUNT1
		;**********************************************************************
		; 100ms timer function calls
		;**********************************************************************
		;....... 100ms  timer counter here.....		
		;
		
		;call counter			
			
        
		;test toggle LED on here...
        ;bsf  	PORTB, POWERLED 		;Turn on LED 
		
		;....................................

        incf    COUNT2, f
		movlw   .10			    ;Compare count to 100 decimal
		subwf   COUNT2, W		;Store the result back in 
		btfss   STATUS, C		;Is the result 0, skip if no
		goto    exittimer
		clrf 	COUNT2
		;**********************************************************************
		; 1000ms timer function calls
		;**********************************************************************
		;....... 1000ms  timer counter here.....		
		;call counter		

		incf    COUNT3, f
		movlw   .30			    ;Compare count to 100 decimal
		subwf   COUNT3, W		;Store the result back in 
		btfss   STATUS, C		;Is the result 0, skip if no
		goto    exittimer
		clrf 	COUNT3
		;**********************************************************************
		; 30000ms timer function calls
		;**********************************************************************
		;....... 30000ms  timer counter here.....		
        ;call counter 	
        
exittimer       
		movlw 	.217		;count 14
		clrf TMR0 ;Clear TMR0 and prescaler
		banksel TMR0
		movwf TMR0
		
        
        
;-------------- Insert no new code below here ---------------------------------
		bcf INTCON, T0IF	;Clear timer overflow flag
		bsf INTCON, T0IE	;Enable interrupts again
		return
;----------------------------------------------------------------------------------
;**********************************************************************************
initTimer
 Global	 initTimer
 GLOBAL  COUNT
 	clrf	COUNT
	return
	end
